/*
   lib functions that is may be usable into other programs / applications
*/

#include "DSV2DBF.ch"

Function _DoValid ( Expression , Message )  // Function borrowed from HMG Samples for VALID process into TEXTBOX control

	If ValType ( Message ) = "U"
		Message := "Invalid Entry"
	EndIf

	If _HMG_IsValidInProgres   

		Return Nil

	Else

		_HMG_IsValidInProgres := .T.
		If ( Expression , Nil , ( MsgStop (Message,'') , This.SetFocus  ) ) 
		_HMG_IsValidInProgres := .F.

	EndIf

Return Nil

*.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._

/*
    Txt2Arr2D : Convert a two dimensional array from text
	
	Caution: - <cRowDelim> and <cColDelim> should not be into data items.
	         - Elements of sub ( second dim ) array of arrays produced by this function are always char type 
	
*/

FUNC Txt2Arr2D(;                 // Convert a two dimensional array from text
                cText,;
				cRowDelim,; 
				cColDelim ) 
				
    LOCA aRVal   := HB_ATOKENS( cText, cRowDelim)
		 
	AEVAL( aRVal, { | c1, i1 | aRVal[ i1 ] := HB_ATOKENS( c1, cColDelim ) } )	 
	
RETU aRVal // Txt2Arr2D()

*.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._
/*
    Arr2D2Txt : Convert  a two dimensional array to a text
	
	Caution: <cRowDelim> and <cColDelim> should not be into data items.
	
*/

FUNC Arr2D2Txt(;                 
                aArry2Dim,;
				cRowDelim,; 
				cColDelim ) 
				
    LOCA cRVal := "",;
	     a1Row := {},;
		 c1Lin := '',;
		 c1Val := '',;		 
		 c1Typ := '',;		 
	     n1stD := 0,;
	     n2ndD := 0,;
		 x1Val
		 
	FOR n1stD := 1 TO LEN( aArry2Dim )
	    a1Row := aArry2Dim[ n1stD ] 
        c1Lin := ''
		FOR n2ndD := 1 TO LEN( a1Row )
		    x1Val := a1Row[ n2ndD ]  
            c1Typ := VALTYPE( x1Val )
            DO CASE
			    CASE c1Typ == "A"           // Dimension ERROR ! ( more than two dim )
			        c1Val := "{...}"
			    CASE c1Typ == "L"
			        c1Val := IF( x1Val, ".T.", ".F." )
			    CASE c1Typ == "N"
			        c1Val := LTRIM( STR( x1Val ) )   // Decimal point ?
			    CASE c1Typ == "D"
			        c1Val := DTOC( x1Val )  // Date format ?
                CASE c1Typ == "C"
			        c1Val := x1Val				
			    OTHE                        // Unknown data type			   
				    c1Val := "???"
            ENDCASE			
		    c1Lin += c1Val + IF( n2ndD < LEN( a1Row ), " ", "" )
	    NEXT x1Val
		cRVal += c1Lin + IF( n1stD < LEN( aArry2Dim ), cRowDelim, "" )
	NEXT a1Row 	
RETU cRVal // Txt2Arr2D()

*.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._
 	
